<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//

define("TIMEOUT_RETRIES", 1);
define("TIMEOUT_RETRIES_FOR_ASMA_AGENT", 3);

define("ENTERPRISE_NAMED_OID_LABEL", "AS");
define("ENTERPRISE_PRIVATE_NAMED_OID_LABEL", "AZ");
define("ENTERPRISE_PRIVATE_NAMED_OID_LABEL2", "AS.1.9999");
define("ENTERPRISE_PREFIX_OID", "1.3.6.1.4.1.2623");
define("ENTERPRISE_PRIVATE_PREFIX_OID", "1.3.6.1.4.1.2623.1.9999");

define("FRAME_UPDATER", "updater");

define("MATCHALL", "*");

define("WEBCONI18N_INI", "conf/i18n.conf");

define("WEBCONCLIENTS_INI", "conf/aswmclients.conf");
define("WEBCONSOURCE_INI", "conf/asma.conf");
define("WEBCONVARS_INI", "conf/aswm.conf");
define("WEBCONCLIENTS_INI2", "../../conf/aswmclients.conf");
define("WEBCONSOURCE_INI2", "../../conf/asma.conf");

define("WEBDEF_BYLOC_INI", "___locale___.php");

define("I18N_CN", "cn");
define("I18N_CN_PREFIX_DIR", "i18n/cn/");
define("I18N_EN", "en");
define("I18N_EN_PREFIX_DIR", "i18n/en/");
define("I18N_JA", "ja");
define("I18N_JA_PREFIX_DIR", "i18n/ja/");
define("I18N_DEFAULT_CTYPE", "iso-8859-1");

define("INIFILE_COMMENT_BEGIN", "#/");
define("INIFILE_COMMENT_END", "/#");
define("INIFILE_COMMENT_SINGLE_LINE", "#");

define("INIFILE_SEC_GLOBAL", "[Global]");
define("INIFILE_SEC_GLOBAL_MULTIPLE", "[Global-Multiple]");
define("INIFILE_SEC_OID", "[OID]");
define("INIFILE_SEC_SUMMARY_CATEGORY", "[Summary-Category]");
define("INIFILE_SEC_SUMMARY_VIEW", "[Summary-View]");
define("INIFILE_SEC_TOP_CATEGORY", "[Top-Category]");
define("INIFILE_SEC_2ND_CATEGORY", "[2nd-Category]");
define("INIFILE_SEC_2ND_CATEGORY_REDEFINE", "[2nd-Category-Redefine]");
define("INIFILE_SEC_OID_SCAN", "[OID-Scan]");
define("INIFILE_SEC_FORCE_TO_ADD_OID", "[Force-To-Add-OID]");
define("INIFILE_SEC_FORCE_TO_DELETE_OID", "[Force-To-Delete-OID]");
define("INIFILE_SEC_OID_RESCAN_MAP", "[OID-Rescan-Map]");
define("INIFILE_SEC_OID_TABLE_ENTRY", "[OID-Table-Entry]");
define("INIFILE_SEC_OID_TABLE_MULTIPLE_INDEX", "[OID-Table-Multiple-Index]");
define("INIFILE_SEC_OID_VALUE_TRANSLATION_TABLE", "[OID-Value-Translation-Table]");
define("INIFILE_SEC_OID_VALUE_TRANSLATION", "[OID-Value-Translation]");
define("INIFILE_SEC_OID_PREFER_DISPLAY_PATTERN", "[OID-Prefer-Display-Pattern]");
define("INIFILE_SEC_POLLING_FOREVER", "[Polling-Forever]");
define("INIFILE_SEC_ALARM_ACTION", "[Alarm-Action]");
define("INIFILE_SEC_POLLING_ACTION", "[Polling-Action]");
define("INIFILE_SEC_CONFIG_ACTION", "[Config-Action]");
define("INIFILE_SEC_RT_CHART", "[RT-Chart]");
define("INIFILE_SEC_TRANSLATE", "[I18N-Translate]");
define("INIFILE_SEC_SECURED_COMMUNITY", "[Secured-Community]");
define("INIFILE_SEC_STATIC_VALUE", "[Static-Value]");
define("INIFILE_SEC_STATIC_EVENT_REMAP", "[Static-Event-Remap]");

define("GLOBAL_SNMP_SOURCE_IP_ADDRESS", "snmp_source_ip_address");
define("GLOBAL_SNMP_SOURCE_COMMUNITY", "snmp_source_community");

define("EMPTY_OID", "0.0");

define("PSEUDO_OID_PREFIX", "PS.");

define("SECOND_CATEGORY_PLATFORM", "P");
define("SECOND_CATEGORY_CASCADE_PLATFORM", "Q");
define("SECOND_CATEGORY_HORIZ_TABLE", "H");
define("SECOND_CATEGORY_EX_HORIZ_TABLE", "X");
define("SECOND_CATEGORY_VERT_TABLE", "V");
define("SECOND_CATEGORY_NEW_WINDOW", "W");
define("SECOND_CATEGORY_FRAME_WINDOW", "F");
define("SECOND_CATEGORY_EXT_PANEL", "E");

define("SECOND_CATEGORY_NEEDSORT", "S");

define("SECOND_CATEGORY_STATISTIC_FIELD_TAGS", "_");
define("SECOND_CATEGORY_NON_STATISTIC_FIELD_TAGS", "X");
define("SECOND_CATEGORY_SOFTRAID_FIELD_TAGS", "Y");

define("OID_ATTR_ALARM", "Alm");
define("OID_ATTR_DEALARM", "DAlm");
define("OID_ATTR_WALARM", "WAlm");
define("OID_ATTR_GROUP", "Grp");
define("OID_ATTR_WATCH", "Wat");
define("OID_ATTR_WATCHX", "WatX");
define("OID_ATTR_WATCHRAID", "WatR");
define("OID_ATTR_SWITCH", "Swh");
define("OID_ATTR_INFO", "Inf");
define("OID_ATTR_INFO_EX", "Infx");
define("OID_ATTR_POP_INFO_EX", "PInfx");
define("OID_ATTR_POP_INFO_RAID", "PInfR");
define("OID_ATTR_POP_INFO_EX_COMPOSITE", "PInfxS");
define("OID_ATTR_HLIMIT", "HLmt");
define("OID_ATTR_LLIMIT", "LLmt");
define("OID_ATTR_WHLIMIT", "WHLmt");
define("OID_ATTR_WLLIMIT", "WLLmt");
define("OID_ATTR_BUTTON", "Btn");
define("OID_ATTR_TABLE", "Tbl");
define("OID_ATTR_HEALTH_TABLE", "HTbl");
define("OID_ATTR_MULTINDEX_TABLE", "CTbl");
define("OID_ATTR_VERTICAL_TABLE", "VTbl");
define("OID_ATTR_VERTICAL_MULTINDEX_TABLE", "CVTbl");
define("OID_ATTR_CONFIG", "Cfg");
define("OID_ATTR_LABEL", "Lbl");
define("OID_ATTR_SEPARATOR", "-");
define("OID_ATTR_MORE", "More");

define("OID_ATTR_LONG_INFO", "LInf");
define("OID_ATTR_ALARM_DATE", "AlmD");
define("OID_ATTR_ALARM_RAID", "AlmR");

define("ALARM_ACTION_REMAP", "ReMap");
define("POLLING_ACTION_REMAP", "ReMap");

define("OID_VALUE_INTEGER", "I");
define("OID_VALUE_STRING", "S");
define("OID_VALUE_WCSTRING", "W");
define("OID_VALUE_IPADDRESS", "A");
define("OID_VALUE_BUTTON", "B");
define("OID_VALUE_OTHER", "X");

define("ALARM_NORMAL", "_");
define("ALARM_WARNING", "W");
define("ALARM_CRITICAL", "C");
define("ALARM_EMPTY", "|");

define("DEBUG_LOGFILE", "/tmp/aswm.log");

header("Cache-Control: no-cache, must-revalidate"); 
header("Pragma: no-cache");

session_start();

snmp_set_quick_print(2);

$aswm_snmp_log = 0;
$dummy_snmp = 0;
$dummy_backplane_id = '6';
$enable_queryevents = 1;
$enable_profile = 0;

define("DEFAULT_SNMP_TIMEOUT", 5000000);
define("SNMPCMD_GET", 0);
define("SNMPCMD_WALK", 1);
define("SNMPCMD_SET", 2);

function __update_timeouts__ ()
{
    static $init_timeout = false;

    if (!$init_timeout) {
        $init_timeout = true;
        $GLOBALS['snmp_retry'][0] = (int)$GLOBALS["snmp_retry_1st_timeout"];
        $GLOBALS['snmp_retry'][1] = (int)$GLOBALS["snmp_retry_2nd_timeout"];
        $GLOBALS['snmp_retry'][2] = (int)$GLOBALS["snmp_retry_3rd_timeout"];
        $GLOBALS['snmp_retry'][3] = (int)$GLOBALS["snmp_retry_4th_timeout"];
    }
}

function __snmpcmd__ ($se, $ip_addr, $community, $oid, $value_type = '', $value = '')
{
    if (!empty($GLOBALS['static_values']) && $se == SNMPCMD_GET) {
        $static_values = $GLOBALS['static_values'];
        if (isset($static_values[$oid]))
            return $static_values[$oid];
    }

    $oid = ereg_replace("\.#\.0$", '.0', $oid);

    __update_timeouts__();

    $oid = str_replace(ENTERPRISE_NAMED_OID_LABEL, ENTERPRISE_PREFIX_OID, $oid);
    $oid = str_replace(ENTERPRISE_PRIVATE_NAMED_OID_LABEL, ENTERPRISE_PRIVATE_PREFIX_OID, $oid);

//    openlog("ASWM [__snmpcmd__]", LOG_CONS | LOG_NDELAY, LOG_USER);
//    syslog(LOG_INFO, "Op [$se]/OID [$oid]");
//    closelog();

    for ($i = 0; $i < 4; $i++) {
        switch ($se) {
            case SNMPCMD_GET:
                $acq = @snmpget($ip_addr, $community, $oid, $GLOBALS['snmp_retry'][$i], 0);
                break;
            case SNMPCMD_WALK:
                $acq = @snmpwalk($ip_addr, $community, $oid, $GLOBALS['snmp_retry'][$i], 0);
                break;
            case SNMPCMD_SET:
                $acq = @snmpset($ip_addr, $community, $oid, $value_type, $value, $GLOBALS['snmp_retry'][$i], 0);
                break;
        }

        if (isset($acq))
            break;
    }
    return $acq;
}

function __dummy_snmpget__ ($value_type)
{
    if (!strcmp($value_type, OID_VALUE_STRING)) {
        return "\"OK\"";
    } elseif (!strcmp($value_type, OID_VALUE_WCSTRING)) {
        return "\"OK\"";
    } elseif (!strcmp($value_type, OID_VALUE_INTEGER)) {
        return "1";
    } elseif (!strcmp($value_type, OID_VALUE_IPADDRESS)) {
        return "0.0.0.0";
    }
    return "\"Uhg?\"";
}


function __acquire__ ($acq, $oid, $value_type)
{
    $acq = ereg_replace('^[^ ]* ', '', chop($acq));

    if (!strcmp($value_type, OID_VALUE_STRING)) {
        $acq = ereg_replace('\"[a-zA-Z:0-9 ]*$', '"', $acq);
        if (strncmp($acq, "\"", 1))
            $acq = "\"$acq\"";
    } elseif (!strcmp($value_type, OID_VALUE_WCSTRING)) {
        $acq = stripcslashes(str_replace('\\\\', '\\', $acq));
        if (strncmp($acq, "\"", 1))
            $acq = "\"$acq\"";
    } elseif (!strcmp($value_type, OID_VALUE_INTEGER)) {
        if (empty($acq))
            $acq = "0";
        else {
            $acq = (string)(int)$acq;
        }
    } elseif (!strcmp($value_type, OID_VALUE_IPADDRESS)) {
        if (empty($acq))
            $acq = "\"0.0.0.0\"";
        else {
            $acq = ereg_replace("[^\.0-9]", '', $acq);
            $acq = "\"$acq\"";
        }
    } else
        $acq = "\"$acq\"";
    return $acq;
}

function acquire_single_value ($ip_addr, $community, $oid, $value_type)
{
    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            $dt = date("H:i:s");
            @fputs($fp, "[$dt] Get .{$oid}.0");
            @fclose($fp);
        }
    }

    if ($GLOBALS["dummy_snmp"] == 0) {
        $acq = __snmpcmd__(SNMPCMD_GET, $ip_addr, $community, ".{$oid}.0");
    } else
        $acq = __dummy_snmpget__($value_type);


    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            @fputs($fp, " = {$acq} ... Done.\n");
            @fclose($fp);
        }
    }

    return __acquire__($acq, $oid, $value_type);
}

function acquire_single_value_non_leaf ($ip_addr, $community, $oid, $value_type)
{
    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            $dt = date("H:i:s");
            @fputs($fp, "[$dt] Get .{$oid}");
            @fclose($fp);
        }
    }

    if ($GLOBALS["dummy_snmp"] == 0) {
        $acq = __snmpcmd__(SNMPCMD_GET, $ip_addr, $community, ".{$oid}");
    } else
        $acq = __dummy_snmpget__($value_type);

    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            @fputs($fp, " = {$acq} ... Done.\n");
            @fclose($fp);
        }
    }

    return __acquire__($acq, $oid, $value_type);
}

function acquire_single_value_concat ($ip_addr, $community, $oid, $concat, $value_type)
{
    $eoid = "{$oid}.{$concat}";
    $acq = acquire_single_value($ip_addr, $community, $eoid, $value_type);
    return str_replace('.0,', ",", ereg_replace('^\"(.*)\"$', '\\1', $acq));
}


function acquire_multiple_values ($ip_addr, $community, $oid)
{
    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            $dt = date("H:i:s");
            @fputs($fp, "[$dt] Walk .{$oid}");
            @fclose($fp);
        }
    }

    $acq = __snmpcmd__(SNMPCMD_WALK, $ip_addr, $community, ".{$oid}");

    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            @fputs($fp, " ... Done.\n");
            @fclose($fp);
        }
    }

    if ($GLOBALS["dummy_snmp"] == 0) {
        foreach ($acq as $ac) {
            $acq2[] = ereg_replace('^[^ ]* ', '', chop($ac));
        }
        return $acq2;
    } else
        return array('1');
}

function apply_single_value ($ip_addr, $community, $oid, $value_type, $value)
{
    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            $dt = date("H:i:s");
            @fputs($fp, "[$dt] Set .{$oid}.0 [$community/$value_type/$value]");
            @fclose($fp);
        }
    }

    if ($GLOBALS["dummy_snmp"] == 0)  {
        $acq = __snmpcmd__(SNMPCMD_SET, $ip_addr, $community, ".{$oid}.0", strtolower($value_type), $value);
    } 

    if ($GLOBALS["aswm_snmp_log"] != 0) {
        $fp = @fopen(DEBUG_LOGFILE, "a");
        if ($fp !== false) {
            @fputs($fp, " ... Done.\n");
            @fclose($fp);
        }
    }

    return $acq;
}

function parse_date ($timestamp)
{
    $dd = date("Y/m/d H:i:s", $timestamp);
    return "$dd";
}

function check_oid_exist($cond_value, $acq)
{
    if (empty($acq))
        return false;
    if (!strncmp($cond_value, "^", 1)) {
        if ((((int)$acq) & ((int)str_replace('^', '', $cond_value))) == 0) {
            return false;
        }
    } elseif (!strncmp($cond_value, "~", 1)) {
        if (!strcmp($cond_value, "~#")) {
            if (strlen($acq) == 0 || !strcmp($acq,"\"\"")) {
                return false;
            }
        } else {
            if (!strcmp($acq, str_replace('~', '', $cond_value))) {
                return false;
            }
        }
    } else {
        if (!strcmp($cond_value, "#")) {
            if (strlen($acq) > 0 && strcmp($acq, "\"\"")) {
                return false;
            }
        } else {
            if (strcmp($acq, $cond_value)) {
                return false;
            }
        }
    }
    return true;
}

function kstrnatcmp ($s1, $s2)
{
    return strnatcmp($s1, $s2);
}

function fetch_display_pattern ($display_pattern_array, $def_attr, $oid)
{
    $pattern = $display_pattern_array[$def_attr];
    if (!empty($display_pattern_array[$oid]))
        $pattern = $display_pattern_array[$oid];
    return $pattern;
}

function boardswitch ($board_switch, $board_switch2)
{
    if (!strcmp($board_switch, "boardFFF2B6")) {
        $board_switch = "grayboard";
        $board_switch2 = "FFFFCC";
    } else {
        $board_switch = "boardFFF2B6";
        $board_switch2 = "FFF2B6";
    }
}

function boardswitch1 ($board_switch)
{
    if (!strcmp($board_switch, "boardFFF2B6")) {
        $board_switch = "grayboard";
    } else {
        $board_switch = "boardFFF2B6";
    }
}

function remove_key ($ax, $t)
{
    $i = -1;
    foreach ($ax as $k => $v) {
        if (!strcmp($k, $t)) {
            $i++;
            array_splice($ax, $i, 1);
            break;
        }
        $i++;
    }
    return $i;
}

function remove_value ($ax, $t)
{
    $i = -1;
    foreach ($ax as $v) {
        if (!strcmp($v, $t)) {
            $i++;
            array_splice($ax, $i, 1);
            break;
        }
        $i++;
    }
    return $i;
}

if (!$GLOBALS["no_i18n"])
    include ($HTTP_SESSION_VARS['localepath']. "___locale___.php");

 ?>