<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</HEAD>
<?php
    $secc = $HTTP_GET_VARS["action"];
    $refresh = $HTTP_GET_VARS["refresh"];
    $chart = $HTTP_GET_VARS["chart"];

    if (empty($refresh))
        $refresh = "0";

    if ($GLOBALS["enable_profile"] > 0) {
        $profile_for_init = $HTTP_SESSION_VARS["profile_for_init"];
        $profile_for_init = "1";
    }

    $postpone_scan_event = (int)$HTTP_SESSION_VARS["postpone_scan_event"];
    $top_category = $HTTP_SESSION_VARS["top_category"];
    $second_category = $HTTP_SESSION_VARS["second_category"];

    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $snmp_entry_attribute = $HTTP_SESSION_VARS["snmp_entry_attribute"];
    $snmp_entry_value_type = $HTTP_SESSION_VARS['snmp_entry_value_type'];
    $snmp_entry_parent_oid = $HTTP_SESSION_VARS["snmp_entry_parent_oid"];
    $snmp_entry_description = $HTTP_SESSION_VARS["snmp_entry_description"];
    $snmp_entry_2nd_category = $HTTP_SESSION_VARS["snmp_entry_2nd_category"];
    $snmp_entry_alarm = $HTTP_SESSION_VARS["snmp_entry_alarm"];
    $alarm_actions = $HTTP_SESSION_VARS["alarm_actions"];
    $alarm_actions_parameters = $HTTP_SESSION_VARS["alarm_actions_parameters"];

    $polling_actions_oid = $HTTP_SESSION_VARS["polling_actions_oid"];
    $polling_actions_condition = $HTTP_SESSION_VARS["polling_actions_condition"];
    $polling_actions = $HTTP_SESSION_VARS["polling_actions"];
    $polling_actions_parameters = $HTTP_SESSION_VARS["polling_actions_parameters"];
    $polling_oid_saved_values = $HTTP_SESSION_VARS["polling_oid_saved_values"];

    $second_category_alarm = $HTTP_SESSION_VARS["second_category_alarm"];
    $second_category_warning_alarm = $HTTP_SESSION_VARS["second_category_warning_alarm"];

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
    $snmp_event_oid = $HTTP_SESSION_VARS["snmp_event_oid"];
    $enterprise_snmp_prefix_oid = $HTTP_SESSION_VARS["enterprise_snmp_prefix_oid"];
    
    $snmp_events = $HTTP_SESSION_VARS["snmp_events"];
    $imitation_events = $HTTP_SESSION_VARS['imitation_events'];
    $ignore_first_action_event = $HTTP_SESSION_VARS['ignore_first_action_event'];

    $static_event_remap = $HTTP_SESSION_VARS['static_event_remap'];
    $polling_forever = $HTTP_SESSION_VARS['polling_forever'];

    $continue_to_process = true;
    $force_to_rewrite_dynacontent = false;
    $force_to_rewrite_dynacontent2 = false;

    if (!empty($polling_actions_oid))
        foreach ($polling_actions_oid as $tag => $oid_type_pair) {
            list($oid, $value_type) = explode(',', $oid_type_pair);
            $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $oid, $value_type);
            list($old_value, $new_value) = explode(',', $polling_actions_condition[$tag]);
            if (check_oid_exist($old_value, $polling_oid_saved_values[$tag])) {
                if (check_oid_exist($new_value, $acq)) {
                    $polling_oid_saved_values[$tag] = $acq;
                    $continue_to_process = false;
                    if (!strcmp($polling_actions[$tag], POLLING_ACTION_REMAP)) {
                        $para = $polling_actions_parameters[$tag];
                        $upd[] = "top.window.location.replace(\"remap.php?s=\" + escape(top.__platform_in_view__) + \"&p=\" + escape(top.__panel_in_view__) + \"&map={$para}\");\n";
                    }
                }
            }
        }

    if (!empty($polling_forever)) {
        foreach ($polling_forever as $oid) {
            $entry_name = $snmp_entry_name[$oid];
            if (!empty($entry_name)) {
                $value_type = $snmp_entry_value_type[$oid];
                $attribute = $snmp_entry_attribute[$oid];
                if (!strcmp($attribute, OID_ATTR_WATCH) || !strcmp($attribute, OID_ATTR_WATCHX) || !strcmp($attribute, OID_ATTR_WATCHRAID) ||
                    !strcmp($attribute, OID_ATTR_INFO)) {
                    $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $oid, $value_type);
                    $force_to_rewrite_dynacontent2 = true;
                    if (!strcmp($attribute, OID_ATTR_WATCHRAID)) {
                        list($nrdisk, $actdisk, $workdisk, $faildisk, $sparedisk, $resync, $recovery) = explode(':', ereg_replace('^\"(.*)\"$', '\\1', $acq));
                        $upd[] = "    top.VAL_{$entry_name}_nrdisk = $nrdisk; top.VAL_{$entry_name}_actdisk = $actdisk; top.VAL_{$entry_name}_workdisk = $workdisk;\n";
                        $upd[] = "    top.VAL_{$entry_name}_faildisk = $faildisk; top.VAL_{$entry_name}_sparedisk = $sparedisk; top.VAL_{$entry_name}_resync = $resync; top.VAL_{$entry_name}_recovery = $recovery;\n";
                    } else {
                        $upd[] = "    top.VAL_{$entry_name} = $acq;\n";
                    }
                    if (!strcmp($attribute, OID_ATTR_WATCH)) {
                        $upd[] = "    if (top.T{$entry_name} != '". ALARM_NORMAL. "')\n";
                        $upd[] = "        top.TRY_{$entry_name} = ". TIMEOUT_RETRIES. ";\n";
                        $upd[] = "    if (top.VAL_{$entry_name} == 0 && top.TRY_{$entry_name} < ". TIMEOUT_RETRIES. ") {\n";
                        $upd[] = "        top.TRY_{$entry_name}++;\n";
                        $upd[] = "        top.VAL_{$entry_name} = top.LSV_{$entry_name};\n";
                        $upd[] = "    } else {\n";
                        $upd[] = "        top.TRY_{$entry_name} = 0;\n";
                        $upd[] = "        top.LSV_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    }\n";

                        $upd[] = "    top.CNT_{$entry_name}++;\n";
                        $upd[] = "    if (top.CNT_{$entry_name} > 8192) top.CNT_{$entry_name} = 1;\n";
                        $upd[] = "    top.AVG_{$entry_name} = Math.round((top.AVG_{$entry_name} * (top.CNT_{$entry_name} - 1) + top.VAL_{$entry_name}) / top.CNT_{$entry_name});\n";
                        $upd[] = "    if (top.VAL_{$entry_name} > top.MAX_{$entry_name})\n";
                        $upd[] = "        top.MAX_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    if (top.VAL_{$entry_name} < top.MIN_{$entry_name})\n";
                        $upd[] = "        top.MIN_{$entry_name} = top.VAL_{$entry_name};\n";
                    }
                }
            }
        }
    }

    if (($event_message = explode('@', $snmp_events)) !== false && $continue_to_process) {
        if (count($event_message) == 2) {
            list($k, $event_list_value) = each($event_message);
            list($k, $next_tick) = each($event_message);
            if (($event_list = explode(';', $event_list_value)) !== false) {
                foreach ($event_list as $event) {
                    if (strlen($event) == 0)
                        continue;
                    list($abb_event_oid, $timestamp) = explode(',', $event);
                    $abb_event_oid = ereg_replace('\.0$', '', $abb_event_oid);
                    $event_oid = ENTERPRISE_NAMED_OID_LABEL. $abb_event_oid;
                    $event_oid = str_replace(ENTERPRISE_PRIVATE_NAMED_OID_LABEL2, ENTERPRISE_PRIVATE_NAMED_OID_LABEL, $event_oid);
                    if (!empty($static_event_remap))
                        if (!empty($static_event_remap[$event_oid]))
                            $event_oid = $static_event_remap[$event_oid];
                    $allevents[$event_oid] = $timestamp;
                }
                if (!empty($allevents)) {
                    asort($allevents);
                    foreach ($allevents as $event_oid => $timestamp) {
                        $attribute = $snmp_entry_attribute[$event_oid];
                        if (!strcmp($attribute, OID_ATTR_ALARM) || !strcmp($attribute, OID_ATTR_DEALARM)
                            || !strcmp($attribute, OID_ATTR_WALARM)) {
                            $each_secc = $snmp_entry_2nd_category[$event_oid];
                            $parent_oid = $snmp_entry_parent_oid[$event_oid];
                            $action_type = $alarm_actions[$event_oid];
                            if (!empty($action_type) && !empty($snmp_entry_alarm[$parent_oid]) &&
                                !$ignore_first_action_event) {
                                $ignore_first_action_event = false;
                                if (!strcmp($action_type, ALARM_ACTION_REMAP)) {
                                    $really_remap = false;
                                    $para = $alarm_actions_parameters[$event_oid];
                                    list($remap_tag, $chk_oid_ex, $chk_flg) = explode(':', $para);
                                    if (!strcmp($chk_flg, '!')) {
                                        if (empty($snmp_entry_name[$chk_oid_ex]))
                                            $really_remap = true;
                                    }
                                    if (!strcmp($chk_flg, '#')) {
                                        if (!empty($snmp_entry_name[$chk_oid_ex]))
                                            $really_remap = true;
                                    }
                                    if ($really_remap) {
                                        $dummy = count($snmp_entry_name);
                                        $upd[] = "top.window.location.replace(\"remap.php?s=\" + escape(top.__platform_in_view__) + \"&p=\" + escape(top.__panel_in_view__) + \"&map={$remap_tag}\");\n";
                                    }
                                    if (!strcmp($attribute, OID_ATTR_ALARM))
                                        $continue_to_process = false;
                                }
                            }

                            if ($continue_to_process) {
                                if (!empty($snmp_entry_alarm[$parent_oid])) {
                                    $parent_name = $snmp_entry_name[$parent_oid];
                                    $parent_attribute = $snmp_entry_attribute[$parent_oid];
                                    if (!strcmp($attribute, OID_ATTR_DEALARM)) {
                                        $second_category_alarm[$each_secc] = str_replace("{$parent_oid}|", "", $second_category_alarm[$each_secc]);
                                        $second_category_warning_alarm[$each_secc] = str_replace("{$parent_oid}|", "", $second_category_warning_alarm[$each_secc]);
                                        $snmp_entry_alarm[$parent_oid] = ALARM_NORMAL;
                                    }
                                    if (!strcmp($attribute, OID_ATTR_WALARM)) {
                                        if (strpos($second_category_warning_alarm[$each_secc], "{$parent_oid}|") === false) {
                                            $second_category_warning_alarm[$each_secc] = "{$second_category_warning_alarm[$each_secc]}{$parent_oid}|";
                                            $second_category_alarm[$each_secc] = str_replace("{$parent_oid}|", "", $second_category_alarm[$each_secc]);
                                        }
                                        $snmp_entry_alarm[$parent_oid] = ALARM_WARNING;
                                    }
                                    if (!strcmp($attribute, OID_ATTR_ALARM)) {
                                        if (strpos($second_category_alarm[$each_secc], "{$parent_oid}|") === false) {
                                            $second_category_alarm[$each_secc] = "{$second_category_alarm[$each_secc]}{$parent_oid}|";
                                            $second_category_warning_alarm[$each_secc] = str_replace("{$parent_oid}|", "", $second_category_warning_alarm[$each_secc]);
                                        }
                                        $snmp_entry_alarm[$parent_oid] = ALARM_CRITICAL;
                                    }
                                    if (!strcmp($attribute, OID_ATTR_DEALARM) || !strcmp($attribute, OID_ATTR_WALARM) ||
                                        !strcmp($attribute, OID_ATTR_ALARM)) {
                                        $upd[] = "    top.T{$parent_name} = \"{$snmp_entry_alarm[$parent_oid]}\";\n";

                                        $entry_description = $snmp_entry_description[$event_oid];
                                        if (strncmp($entry_description, '!', 1)) {
                                            $upd[] = "    top.MSG_{$parent_name} = \"{$entry_description}\";\n";
                                        } else {
                                            if (!strcmp(substr($entry_description, 1, 1), 'R')) {
                                                list($cod, $raiderrinfo, $raiddevnms, $raiddevsts, $imitateoid) = explode(':', $entry_description);
                                                $acq = ereg_replace('^\"(.*)\"$', '\\1', acquire_single_value($snmp_source_ip_address, $snmp_source_community, $raiderrinfo, OID_ATTR_STRING));
                                                if (!empty($acq)) {
                                                    $totalert = '';
                                                    foreach (explode(':', $acq) as $eachalert) {
                                                        if ((int)$eachalert >= 1 && (int)$eachalert <= 9) {
                                                            $totalert = "{$totalert}; ". $HTTP_SESSION_VARS['msg_mdAlert'. (string)((int)$eachalert)];
                                                        }
                                                    }
                                                    if (!empty($raiddevnms)) {
                                                        $totdev = '';

                                                        $acq = ereg_replace('^[\"]*([^\"]*)[\"]*$', '\\1', acquire_single_value($snmp_source_ip_address, $snmp_source_community, $raiddevnms, OID_ATTR_STRING));
                                                        $acq2 = ereg_replace('^\"(.*)\"$', '\\1', acquire_single_value($snmp_source_ip_address, $snmp_source_community, $raiddevsts, OID_ATTR_STRING));
                                                        if (!empty($acq2))
                                                            $sts = explode(':', $acq2);
                                                        if (!empty($acq)) {
                                                            foreach (explode(':', $acq) as $i => $rddev) {
                                                                if ((int)$sts[$i] != 0) {
                                                                    $dummySCSImapper = $HTTP_SESSION_VARS['dummySCSImapper'];
                                                                    $scsi = "";
                                                                    foreach ($dummySCSImapper as $regx => $target) {
                                                                        $scsi = ' ('. ereg_replace($regx, $rddev, $target). ')';
                                                                    }
                                                                    $totdev = "{$totdev}, /dev/{$rddev}{$scsi}";
                                                                }
                                                            }
                                                            if (!empty($totdev))
                                                                $totalert = "{$totalert}. [". substr($totdev, 2). "] is(are) bad";
                                                        }
                                                    }
                                                    if (!empty($totalert)) {
                                                        $upd[] = "    top.MSG_{$parent_name} = \"Device(s) ". substr($totalert, 2). ".\";\n";
                                                    }

                                                    $acq = ereg_replace('^\"(.*)\"$', '\\1', acquire_single_value($snmp_source_ip_address, $snmp_source_community, $parent_oid, OID_ATTR_STRING));
                                                    if (!empty($acq)) {
                                                        list($a, $b, $c, $d, $e, $f, $g, $st) = explode(':', $acq);
                                                        if ((int)$st != 0) {
                                                            $ev = str_replace(ENTERPRISE_PRIVATE_NAMED_OID_LABEL. '.', ENTERPRISE_PRIVATE_PREFIX_OID. '.', $imitateoid);
                                                            $ev = str_replace(ENTERPRISE_PREFIX_OID. '.', '.', $ev);
                                                            $imitation[$imitateoid] = $ev;
                                                        }
                                                    }
                                                }
                                            }
                                            if (!strcmp(substr($entry_description, 1, 1), 'U')) {
                                                list($cod, $walmoid, $desc) = explode(':', $entry_description);
                                                $upd[] = "    top.MSG_{$parent_name} = \"{$desc}\";\n";
                                                if (is_array($imitation)) {
                                                    remove_key(&$imitation, $walmoid);
                                                }
                                                $remove_imitation_later[$walmoid] = $walmoid;
                                            }
                                        }

                                        $dummy = parse_date($timestamp);
                                        $upd[] = "    top.MSGD_{$parent_name} = \"{$dummy}\";\n";
                                        $force_to_rewrite_dynacontent = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    $imitation_events = '';
    if (!empty($imitation)) {
        if (is_array($imitation)) {
            foreach ($imitation as $walm => $abb_oid) {
                if (!empty($remove_imitation_later)) {
                    if (!in_array($walm, $remove_imitation_later)) {
                        $imitation_events = "{$imitation_events};{$abb_oid}";
                    }
                } else
                    $imitation_events = "{$imitation_events};{$abb_oid}";
            }
        }
    }

    foreach ($top_category as $id => $name) {
        foreach ($second_category as $sid => $sname) {
            if (strpos($sid, $id) !== false && strpos($sid, $id) == 0) {
                $flash = $top_category_flash[$id];
                if (!strcmp($flash, '1')) {
                    if (strlen($second_category_warning_alarm[$sid]) <= 1 && strlen($second_category_alarm[$sid]) <= 1) {
                        $dummy = ALARM_NORMAL;
                    }
                    if (strlen($second_category_warning_alarm[$sid]) > 1) {
                        $dummy = ALARM_WARNING;
                    }
                    if (strlen($second_category_alarm[$sid]) > 1) {
                        $dummy = ALARM_CRITICAL;
                    }
                    $upd[] = "    top.frames[3].A{$sid} = \"{$dummy}\";\n";
                    $upd_summ[] = "        top.frames[4].A{$sid} = \"{$dummy}\";\n";
                }
            }
        }
    }

?>
<script language="javascript">
<!--
function triggleEverything ()
{
<?php

                        for ($i = 0; $i < count($upd); $i++) {
                            echo $upd[$i];
                        }

                        if ($force_to_rewrite_dynacontent) {?>
    if (top.frames[4].rewriteDynaContent)
        top.frames[4].rewriteDynaContent();

<?php                   }

                        if ($force_to_rewrite_dynacontent2) {?>
    if (top.frames[1].rewriteDynaContent)
        top.frames[1].rewriteDynaContent();
<?php                   }

                        if (!strcmp($refresh, "1")) {?>

    if (top.__in_summary_view__) {
        top.frames[0].location.replace("__update2__.php");
<?php
                            for ($i = 0; $i < count($upd_summ); $i++) {
                                echo $upd_summ[$i];
                            }
?>
    } <?php

                        }

                        if (!empty($secc) && !strcmp($refresh, "1")) {
?>
else {
        if (!top.__platform_in_form_submit__)
            top.frames[0].location.replace("__update__.php?action=<?php echo $secc;?>");
    }

<?php
                        } elseif (!empty($chart)) {
?>
else {
        top.frames[0].location.replace("__update3__.php?chart=<?php echo $chart;?>");
    }
<?php
                        }
?>

}

function periodical ()
{
    if (top.__refresh_enable__ == 1) {
        if (top.frames[1].refreshLocator)
            top.frames[1].refreshLocator();

<?php
                        if (!empty($chart)) {
?>
        self.window.location.replace("__queryevents__.php?chart=<?php echo $chart;?>&refresh=<?php echo $refresh;?>");
<?php
                        } elseif (!empty($secc)) {
?>
        self.window.location.replace("__queryevents__.php?action=<?php echo $secc;?>&refresh=<?php echo $refresh;?>");
<?php
                        } else {
?>
        self.window.location.replace("__queryevents__.php?refresh=<?php echo $refresh;?>");
<?php
                        }
?>
    }
    top.frames[3]._health_heartbeat_ = 0;
    top.frames[3]._no_apache_detect_ = false;
}

function waitForMonitorEnabled()
{
    if (top.__refresh_enable__ == 1) {
        top.__healthTimeOut__ =  setTimeout("periodical()", top.__refresh_milliseconds__);
    } else
        setTimeout("waitForMonitorEnabled()", top.__refresh_milliseconds__);

    top.frames[3]._health_heartbeat_ = 0;
    top.frames[3]._no_apache_detect_ = false;
}
//-->
</script>
<BODY BGCOLOR="#CEE7FF" background="./images/f2-bg.gif" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
<table cellpadding="1" cellspacing="0" border="0" width="100%">
<tr><td valign=top class=yellowboard id=medium>&nbsp;<br><br><br></td></tr>
</table>
</BODY>
<script language="javascript">
<!--
<?php
                        if ($postpone_scan_event > TIMEOUT_RETRIES_FOR_ASMA_AGENT) {?>
top.__refresh_enable__ = 0;
top.frames[3]._no_asma_detect_ = true;
<?php
                        }
?>

triggleEverything();

if (top.__refresh_enable__ == 1)
    top.__healthTimeOut__ =  setTimeout("periodical()", top.__refresh_milliseconds__);
else {
    setTimeout("waitForMonitorEnabled()", top.__refresh_milliseconds__);
}

top.frames[3]._health_heartbeat_ = 0;
top.frames[3]._no_apache_detect_ = false;
//-->
</script>

</HTML>