<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");

    $secc = $HTTP_GET_VARS["action"];
    $refresh = $HTTP_GET_VARS["refresh"];
    $chart = $HTTP_GET_VARS["chart"];

    if (empty($refresh))
        $refresh = "0";

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
    $snmp_event_oid = $HTTP_SESSION_VARS["snmp_event_oid"];
    $snmp_events = $HTTP_SESSION_VARS["snmp_events"];
    $imitation_events = $HTTP_SESSION_VARS['imitation_events'];
    $postpone_scan_event = (int)$HTTP_SESSION_VARS["postpone_scan_event"];

    if (($event_message = explode('@', $snmp_events)) !== false) {
        if (count($event_message) == 2) {
            list($k, $last_events) = each($event_message);
            list($k, $next_tick) = each($event_message);
        }
    }

    $dummy = '';

    if ($GLOBALS["enable_queryevents"] > 0) {
        $new_events = acquire_single_value_concat($snmp_source_ip_address, $snmp_source_community, $snmp_event_oid, $next_tick, OID_VALUE_STRING);
        if (strlen($new_events) > 0) {
            $snmp_events = $new_events;
            if (!empty($imitation_events)) {
                foreach (explode(';', $imitation_events) as $imitate_abb_event) {
                    $snmp_events = ";{$imitate_abb_event},{$next_tick}{$snmp_events}";
                }
            }
            $postpone_scan_event = 0;
        } else {
            $snmp_events = "@{$next_tick}";
            $postpone_scan_event++;
        }
    } else
        $snmp_events = "@0";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</HEAD>
<BODY BGCOLOR="#CEE7FF" background="/images/f2-bg.gif">
<table cellpadding="1" cellspacing="0" border="0" width="100%">
<tr><td valign=top class=yellowboard id=medium>&nbsp;<br><br><br></td></tr>
</table>
</BODY>
<script language="javascript">
<!--
<?php
    if (!empty($chart)) {
?>
    self.window.location.replace("__health__.php?chart=<?php echo $chart;?>&refresh=<?php echo $refresh;?>");
<?php
    } elseif (!empty($secc)) {
?>
    self.window.location.replace("__health__.php?action=<?php echo $secc;?>&refresh=<?php echo $refresh;?>");
<?php
    } else {
?>
    self.window.location.replace("__health__.php?refresh=<?php echo $refresh;?>");
<?php
    }
?>
//-->
</script>
</HTML>