<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<?php

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $snmp_entry_value_type = $HTTP_SESSION_VARS["snmp_entry_value_type"];
    $snmp_entry_attribute = $HTTP_SESSION_VARS["snmp_entry_attribute"];

    $summary_category = $HTTP_SESSION_VARS["summary_category"];
    $summary_category_value_type = $HTTP_SESSION_VARS["summary_category_value_type"];
    $summary_category_attribute = $HTTP_SESSION_VARS["summary_category_attribute"];
    $summary_view_oid_refresh = $HTTP_SESSION_VARS["summary_view_oid_refresh"];

    if (!empty($summary_view_oid_refresh))
        foreach ($summary_view_oid_refresh as $entry_oid) {
            $entry_name = $snmp_entry_name[$entry_oid];
            if (!empty($entry_name)) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_attribute = $snmp_entry_attribute[$entry_oid];
                if (!strcmp($entry_attribute, OID_ATTR_WATCH) || !strcmp($entry_attribute, OID_ATTR_WATCHX) || !strcmp($entry_attribute, OID_ATTR_WATCHRAID) ||
                    !strcmp($entry_attribute, OID_ATTR_INFO)) {
                    $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                    if (!strcmp($entry_attribute, OID_ATTR_WATCHRAID)) {
                        list($nrdisk, $actdisk, $workdisk, $faildisk, $sparedisk, $resync, $recovery) = explode(':', ereg_replace('^\"(.*)\"$', '\\1', $acq));
                        $upd[] = "    top.VAL_{$entry_name}_nrdisk = $nrdisk; top.VAL_{$entry_name}_actdisk = $actdisk; top.VAL_{$entry_name}_workdisk = $workdisk;\n";
                        $upd[] = "    top.VAL_{$entry_name}_faildisk = $faildisk; top.VAL_{$entry_name}_sparedisk = $sparedisk; top.VAL_{$entry_name}_resync = $resync; top.VAL_{$entry_name}_recovery = $recovery;\n";
                    } else
                        $upd[] = "    top.VAL_{$entry_name} = $acq;\n";
                    if (!strcmp($entry_attribute, OID_ATTR_WATCH)) {
                        $upd[] = "    if (top.T{$entry_name} != '". ALARM_NORMAL. "')\n";
                        $upd[] = "        top.TRY_{$entry_name} = ". TIMEOUT_RETRIES. ";\n";
                        $upd[] = "    if (top.VAL_{$entry_name} == 0 && top.TRY_{$entry_name} < ". TIMEOUT_RETRIES. ") {\n";
                        $upd[] = "        top.TRY_{$entry_name}++;\n";
                        $upd[] = "        top.VAL_{$entry_name} = top.LSV_{$entry_name};\n";
                        $upd[] = "    } else {\n";
                        $upd[] = "        top.TRY_{$entry_name} = 0;\n";
                        $upd[] = "        top.LSV_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    }\n";

                        $upd[] = "    top.CNT_{$entry_name}++;\n";
                        $upd[] = "    if (top.CNT_{$entry_name} > 8192) top.CNT_{$entry_name} = 1;\n";
                        $upd[] = "    top.AVG_{$entry_name} = Math.round((top.AVG_{$entry_name} * (top.CNT_{$entry_name} - 1) + top.VAL_{$entry_name}) / top.CNT_{$entry_name});\n";
                        $upd[] = "    if (top.VAL_{$entry_name} > top.MAX_{$entry_name})\n";
                        $upd[] = "        top.MAX_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    if (top.VAL_{$entry_name} < top.MIN_{$entry_name})\n";
                        $upd[] = "        top.MIN_{$entry_name} = top.VAL_{$entry_name};\n";
                    }
                }
            }
        }
    
    if (!empty($summary_category_value_type))
        foreach ($summary_category_value_type as $entry_oid => $value_type) {
            $attribute = $summary_category_attribute[$entry_oid];
            $entry_name = $summary_category[$entry_oid];
            if (!strcmp($attribute, OID_ATTR_WATCH) || !strcmp($attribute, OID_ATTR_WATCHX) || !strcmp($attribute, OID_ATTR_WATCHRAID)) {
                $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                $upd[] = "    top.frames[4].VAL_{$entry_name} = $acq;\n";
            }
        }
?>
<HTML>
<HEAD>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</HEAD>
<script language="javascript">
<!--
function periodical ()
{
<?php
    for ($i = 0; $i < count($upd); $i++) {
        echo $upd[$i];
    }
?>

    if (top.frames[4].rewriteDynaContent)
        top.frames[4].rewriteDynaContent();
}
//-->
</script>
<BODY BGCOLOR="#CEE7FF" background="/images/bg.gif" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
</BODY>
<script language="javascript">
<!--
periodical();
//-->
</script>
</HTML>
