<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");
    include("___defines2___.php");

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<head>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
<title>ASUS System Web-base Management (<?php echo $snmp_source_ip_address;?>)</title></head>
<BODY></BODY>
<?php
    $platform = $HTTP_GET_VARS["s"];
    $panel = $HTTP_GET_VARS["p"];
    $restart = $HTTP_GET_VARS["rs"];
    if (!empty($restart)) {
        session_unset();
        session_destroy();
        echo "<script language=javascript>\n";
        echo "<!--\n";

        if (!strcmp($restart, 'def')) {
            echo "top.location.replace(\"./index.php?rs=def&s=\" + escape(\"{$platform}\") + \"&p=\" + escape(\"{$panel}\"));\n";
        } else {
            echo "top.location.replace(\"./index.php?s=\" + escape(\"{$platform}\") + \"&p=\" + escape(\"{$panel}\"));\n";
        }
        echo "//-->\n";
        echo "</script>\n";
        exit();
    }


    $remap = $HTTP_GET_VARS["map"];

    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $snmp_entry_oid = $HTTP_SESSION_VARS["snmp_entry_oid"];
    $snmp_entry_value_type = $HTTP_SESSION_VARS["snmp_entry_value_type"];
    $snmp_entry_attribute = $HTTP_SESSION_VARS["snmp_entry_attribute"];
    $snmp_entry_parent_oid = $HTTP_SESSION_VARS["snmp_entry_parent_oid"];
    $snmp_entry_description = $HTTP_SESSION_VARS["snmp_entry_description"];
    $snmp_entry_2nd_category = $HTTP_SESSION_VARS["snmp_entry_2nd_category"];
    $snmp_entry_alarm = $HTTP_SESSION_VARS["snmp_entry_alarm"];

    $snmp_entry_hlimit = $HTTP_SESSION_VARS["snmp_entry_hlimit"];
    $snmp_entry_llimit = $HTTP_SESSION_VARS["snmp_entry_llimit"];
    $snmp_entry_whlimit = $HTTP_SESSION_VARS["snmp_entry_whlimit"];
    $snmp_entry_wllimit = $HTTP_SESSION_VARS["snmp_entry_wllimit"];
    $snmp_entry_pop_extended_info = $HTTP_SESSION_VARS["snmp_entry_pop_extended_info"];
    $snmp_entry_config = $HTTP_SESSION_VARS["snmp_entry_config"];

    $second_category = $HTTP_SESSION_VARS["second_category"];
    $second_category_alarm = $HTTP_SESSION_VARS["second_category_alarm"];
    $second_category_warning_alarm = $HTTP_SESSION_VARS["second_category_warning_alarm"];
    $second_category_sort = $HTTP_SESSION_VARS["second_category_sort"];

    $snmp_entry_rescan_map = $HTTP_SESSION_VARS["snmp_entry_rescan_map"];
    $map = $HTTP_SESSION_VARS[$remap];

    $snmp_entry_raw_buffer_reserve_for_remap = $HTTP_SESSION_VARS["snmp_entry_raw_buffer_reserve_for_remap"];

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
    $snmp_event_oid = $HTTP_SESSION_VARS["snmp_event_oid"];
    $snmp_events = $HTTP_SESSION_VARS["snmp_events"];

    $snmp_entry_rescan_map_second_category = $HTTP_SESSION_VARS["snmp_entry_rescan_map_second_category"];

    $force_to_add_oids = $HTTP_SESSION_VARS['force_to_add_oids'];
    $force_to_delete_oids = $HTTP_SESSION_VARS['force_to_delete_oids'];

    foreach ($second_category as $id => $name)
        $$id = $HTTP_SESSION_VARS[$id];

    if (!empty($map)) {
        $secondc = $snmp_entry_rescan_map_second_category[$remap];
        $second_category_alarm[$secondc] = ALARM_EMPTY;
        $second_category_warning_alarm[$secondc] = ALARM_EMPTY;
        foreach ($$secondc as $oid => $att) {
            if (!empty($snmp_entry_alarm[$oid]))
                $snmp_entry_alarm[$oid] = ALARM_NORMAL;
        }

        foreach ($map as $oid => $ex_oid_val) {
            list($ex_oid, $ex_vtype, $ex_val) = explode(',', $ex_oid_val);
            $buffer = '';
            if (!empty($snmp_entry_raw_buffer_reserve_for_remap[$oid])) {
                $buffer = $snmp_entry_raw_buffer_reserve_for_remap[$oid];

                $already_here = !empty($snmp_entry_name[$oid]);
                $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $ex_oid, $ex_vtype);
                $should_exist = (boolean)check_oid_exist($ex_val, $acq);

                list($xoid, $name, $value_type, $attribute, $web_category, $parent_oid, $description) = explode(',', $buffer);
                list($topc, $secondc) = explode('.', $web_category);


                if ($should_exist) {
                    $really_ok_to_add = false;

                    if (!empty($force_to_delete_oids)) {
                        if (empty($force_to_delete_oids[$oid]))
                            $really_ok_to_add = true;
                    } else
                        $really_ok_to_add = true;

                    if (!$already_here && $really_ok_to_add) {

                        $snmp_entry_name[$oid] = $name;
                        $snmp_entry_oid[$name] = $oid;
                        $snmp_entry_value_type[$oid] = $value_type;
                        $snmp_entry_attribute[$oid] = $attribute;

                        if (strcmp($description, "_"))
                            $snmp_entry_description[$oid] = stripcslashes($description);

                        $ok_to_2nd_cat = false;
                        if (!strcmp($parent_oid, EMPTY_OID)) {
                            $ok_to_2nd_cat = true;
                        } else {
                            $snmp_entry_parent_oid[$oid] = $parent_oid;
                            if (strpos($parent_oid, ':') !== false)
                                $ok_to_2nd_cat = true;
                            else {
                                $parent_attribute = $snmp_entry_attribute[$parent_oid];
                                if (!strcmp($parent_attribute, OID_ATTR_POP_INFO_EX_COMPOSITE)) {
                                    $parent_name = $snmp_entry_name[$parent_oid];
                                    $array = "snmp_composite_info_ex_{$parent_name}";
                                    ${$array}[] = $oid;
                                    $snmp_entry_composite_info_ex[$array] = $array;
                                    $ok_to_2nd_cat = true;
                                }
                            }
                        }

                        if ($ok_to_2nd_cat) {
                            ${$secondc}[$oid] = $attribute;
                            if (!strcmp($second_category_sort[$secondc], SECOND_CATEGORY_NEEDSORT))
                                uksort(${$secondc}, 'kstrnatcmp');
                        }

                        $snmp_entry_2nd_category[$oid] = $secondc;

                        if (!strcmp($attribute, OID_ATTR_ALARM) || !strcmp($attribute, OID_ATTR_DEALARM)
                            || !strcmp($attribute, OID_ATTR_WALARM)) {
                            $snmp_entry_alarm[$parent_oid] = ALARM_NORMAL;
                        }


                        if (!strcmp($attribute, OID_ATTR_HLIMIT)) {
                            $snmp_entry_hlimit[$parent_oid] = $oid;
                        }
                        if (!strcmp($attribute, OID_ATTR_LLIMIT)) {
                            $snmp_entry_llimit[$parent_oid] = $oid;
                        }
                        if (!strcmp($attribute, OID_ATTR_WHLIMIT)) {
                            $snmp_entry_whlimit[$parent_oid] = $oid;
                        }
                        if (!strcmp($attribute, OID_ATTR_WLLIMIT)) {
                            $snmp_entry_wllimit[$parent_oid] = $oid;
                        }

                        if (!empty($snmp_entry_name[$parent_oid])) {
                            if (!strcmp($attribute, OID_ATTR_POP_INFO_EX) || !strcmp($attribute, OID_ATTR_POP_INFO_EX_COMPOSITE)) {
                                $snmp_entry_pop_extended_info[$parent_oid] = $oid;
                            }

                            if (!strcmp($attribute, OID_ATTR_CONFIG)) {
                                $snmp_entry_config[$parent_oid] = $oid;
                            }
                        }
                    }
                } else {
                    $really_ok_to_remove = false;
                    if (!empty($force_to_add_oids)) {
                        if (empty($force_to_add_oids[$oid]))
                            $really_ok_to_remove = true;
                    } else
                        $really_ok_to_remove = true;

                    if ($already_here && $really_ok_to_remove) {
                        remove_key(&$snmp_entry_name, $oid);
                        remove_key(&$snmp_entry_oid, $name);
                        remove_key(&$snmp_entry_value_type, $oid);
                        remove_key(&$snmp_entry_attribute, $oid);
                        remove_key(&$snmp_entry_parent_oid, $oid);
                        remove_key(&$snmp_entry_description, $oid);
                        remove_key(&$$secondc, $oid);

                        if (!strcmp($second_category_sort[$secondc], SECOND_CATEGORY_NEEDSORT))
                            uksort($$secondc, 'kstrnatcmp');

                        remove_key(&$snmp_entry_2nd_category, $oid);

                        if (!strcmp($attribute, OID_ATTR_HLIMIT)) {
                            remove_key(&$snmp_entry_hlimit, $oid);
                        }
                        if (!strcmp($attribute, OID_ATTR_LLIMIT)) {
                            remove_key(&$snmp_entry_llimit, $oid);
                        }
                        if (!strcmp($attribute, OID_ATTR_WHLIMIT)) {
                            remove_key(&$snmp_entry_whlimit, $oid);
                        }
                        if (!strcmp($attribute, OID_ATTR_WLLIMIT)) {
                            remove_key(&$snmp_entry_wllimit, $oid);
                        }

                        if (empty($snmp_entry_name[$parent_oid])) {
                            if (!strcmp($attribute, OID_ATTR_POP_INFO_EX)) {
                                remove_key(&$snmp_entry_pop_extended_info, $parent_oid);
                            }

                            if (!strcmp($attribute, OID_ATTR_CONFIG)) {
                                remove_key(&$snmp_entry_config, $parent_oid);
                            }
                        }
                    }
                }
            }
        }
        $array = "oid_seq_modify_actions_{$secondc}";
        if (!empty(${$array})) {
            foreach (${$array} as $oid => $act) {
                if (!strcmp($act, OID_SEQ_MODIFY_ACTION_MOVE_TO_TAIL)) {
                    if (!empty(${$secondc}[$oid])) {
                        $attr = ${$secondc}[$oid];
                        remove_key(&${$secondc}, $oid);
                        ${$secondc}[$oid] = $attr;
                    }
                }
            }
        }
    }
    ksort($snmp_entry_2nd_category);
    $snmp_events = acquire_single_value_concat($snmp_source_ip_address, $snmp_source_community, $snmp_event_oid, "0", OID_VALUE_STRING);
?>
<script language=javascript>
<!--
    top.location.replace("framewrk.php?s=" + escape("<?php echo $platform;?>") + "&p=" + escape("<?php echo $panel;?>"));
//-->
</script>
</HTML>
