<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<?php
    $secc = $HTTP_GET_VARS["action"];
    $remap = '';
    $always_rewriteDynaContent = true;

    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $snmp_entry_oid = $HTTP_SESSION_VARS["snmp_entry_oid"];
    $snmp_entry_value_type = $HTTP_SESSION_VARS["snmp_entry_value_type"];
    $snmp_entry_value_translation = $HTTP_SESSION_VARS["snmp_entry_value_translation"];

    $snmp_entry_rescan_map = $HTTP_SESSION_VARS["snmp_entry_rescan_map"];

    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];

    $secured_community = $HTTP_SESSION_VARS["secured_community"];
    $config_actions = $HTTP_SESSION_VARS["config_actions"];

    $has_set_threshold_id1 = !empty($HTTP_POST_VARS["_SET_THRESHOLD_ID1_"]);
    $has_set_threshold_id1 = ($has_set_threshold_id1 ? (strlen(chop($HTTP_POST_VARS["_SET_THRESHOLD_ID1_"])) > 0) : false);
    $has_set_threshold_id2 = !empty($HTTP_POST_VARS["_SET_THRESHOLD_ID2_"]);
    $has_set_threshold_id2 = ($has_set_threshold_id2 ? (strlen(chop($HTTP_POST_VARS["_SET_THRESHOLD_ID2_"])) > 0) : false);
    $has_set_threshold_id3 = !empty($HTTP_POST_VARS["_SET_THRESHOLD_ID3_"]);
    $has_set_threshold_id3 = ($has_set_threshold_id3 ? (strlen(chop($HTTP_POST_VARS["_SET_THRESHOLD_ID3_"])) > 0) : false);
    $has_set_threshold_id4 = !empty($HTTP_POST_VARS["_SET_THRESHOLD_ID4_"]);
    $has_set_threshold_id4 = ($has_set_threshold_id4 ? (strlen(chop($HTTP_POST_VARS["_SET_THRESHOLD_ID4_"])) > 0) : false);

    function jscript_config_action ($oid, $act_arr, $cfg_val)
    {
        global $snmp_source_ip_address, $snmp_source_community;

        $raw_acts = $act_arr[$oid];
        if (empty($raw_acts))
            return '';

        $res = '';
        list($prepost, $chkval, $actlst) = explode(':', $raw_acts);

        if (!strcmp($prepost, 'post')) {

            if (!check_oid_exist($chkval, $cfg_val))
                return $res;

            $acts = explode(',',$actlst);
            foreach ($acts as $act) {
                $subacs = explode('!', $act);
                $sub = current($subacs);
                if (!strcmp($sub, 'ifeqi')) {
                    $chkoid = next($subacs);
                    $condval = next($subacs);
                    $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $chkoid, OID_VALUE_INTEGER);
                    if (!check_oid_exist($condval, $acq))
                        break;
                }
                if (!strcmp($sub, 'shutdown')) {
                    $res .= "    top.close();\n";
                }
                if (!strcmp($sub, 'setreboot')) {
                    $res .= "    top.__already_set_reboot__ = true;\n";
                }
            }
        }
        return $res;
    }

    if (!empty($$secc)) {
        $$secc = $HTTP_SESSION_VARS[$secc];

        if (!$has_set_threshold_id1 && !$has_set_threshold_id2 &&
            !$has_set_threshold_id3 && !$has_set_threshold_id4) {
            foreach ($$secc as $entry_oid => $entry_type) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_name = $snmp_entry_name[$entry_oid];
                if (!strcmp($entry_type, OID_ATTR_WATCH) || !strcmp($entry_type, OID_ATTR_WATCHX) || !strcmp($entry_type, OID_ATTR_WATCHRAID) ||
                    !strcmp($entry_type, OID_ATTR_INFO)) {
                    $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                    if (!strcmp($entry_type, OID_ATTR_WATCHRAID)) {
                        list($nrdisk, $actdisk, $workdisk, $faildisk, $sparedisk, $resync, $recovery, $errorbit) = explode(':', ereg_replace('^\"(.*)\"$', '\\1', $acq));
                        $upd[] = "    top.VAL_{$entry_name}_nrdisk = $nrdisk; top.VAL_{$entry_name}_actdisk = $actdisk; top.VAL_{$entry_name}_workdisk = $workdisk;\n";
                        $upd[] = "    top.VAL_{$entry_name}_faildisk = $faildisk; top.VAL_{$entry_name}_sparedisk = $sparedisk; top.VAL_{$entry_name}_resync = $resync; top.VAL_{$entry_name}_recovery = $recovery;\n";
                    } else
                        $upd[] = "    top.VAL_{$entry_name} = $acq;\n";
                    if (!strcmp($entry_type, OID_ATTR_WATCH)) {
                        $upd[] = "    if (top.T{$entry_name} != '". ALARM_NORMAL. "')\n";
                        $upd[] = "        top.TRY_{$entry_name} = ". TIMEOUT_RETRIES. ";\n";
                        $upd[] = "    if (top.VAL_{$entry_name} == 0 && top.TRY_{$entry_name} < ". TIMEOUT_RETRIES. ") {\n";
                        $upd[] = "        top.TRY_{$entry_name}++;\n";
                        $upd[] = "        top.VAL_{$entry_name} = top.LSV_{$entry_name};\n";
                        $upd[] = "    } else {\n";
                        $upd[] = "        top.TRY_{$entry_name} = 0;\n";
                        $upd[] = "        top.LSV_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    }\n";

                        $upd[] = "    top.CNT_{$entry_name}++;\n";
                        $upd[] = "    if (top.CNT_{$entry_name} > 8192) top.CNT_{$entry_name} = 1;\n";
                        $upd[] = "    top.AVG_{$entry_name} = Math.round((top.AVG_{$entry_name} * (top.CNT_{$entry_name} - 1) + top.VAL_{$entry_name}) / top.CNT_{$entry_name});\n";
                        $upd[] = "    if (top.VAL_{$entry_name} > top.MAX_{$entry_name})\n";
                        $upd[] = "        top.MAX_{$entry_name} = top.VAL_{$entry_name};\n";
                        $upd[] = "    if (top.VAL_{$entry_name} < top.MIN_{$entry_name})\n";
                        $upd[] = "        top.MIN_{$entry_name} = top.VAL_{$entry_name};\n";
                    }
                }

                if (!strcmp($entry_type, OID_ATTR_HEALTH_TABLE)) {
                    $table_indexes = acquire_multiple_values($snmp_source_ip_address, $snmp_source_community, $entry_oid);
                    $table_entry_name = $HTTP_SESSION_VARS["{$entry_name}_name"];
                    $table_entry_value_type = $HTTP_SESSION_VARS["{$entry_name}_value_type"];
                    $table_entry_description = $HTTP_SESSION_VARS["{$entry_name}_description"];
                    $table_entry_attribute = $HTTP_SESSION_VARS["{$entry_name}_attribute"];
                    if (!empty($table_indexes))
                        foreach ($table_indexes as $index_value) {
                            foreach ($table_entry_name as $each_entry_oid => $each_entry_name) {
                                $var_full_name = str_replace('.', '_', "{$entry_name}_{$each_entry_name}_{$index_value}");
                                $full_each_oid = "$each_entry_oid.$index_value";
                                $each_value_type = $table_entry_value_type[$each_entry_oid];
                                $acq = acquire_single_value_non_leaf($snmp_source_ip_address, $snmp_source_community, $full_each_oid, $each_value_type);
                                $upd[] = "    top.VAL_{$var_full_name} = $acq;\n";
                                if (!strcmp($table_entry_attribute[$each_entry_oid], OID_ATTR_WATCH)) {
                                    $upd[] = "    if (top.T{$var_full_name} != '". ALARM_NORMAL. "')\n";
                                    $upd[] = "        top.TRY_{$var_full_name} = ". TIMEOUT_RETRIES. ";\n";
                                    $upd[] = "    if (top.VAL_{$var_full_name} == 0 && top.TRY_{$var_full_name} < ". TIMEOUT_RETRIES. ") {\n";
                                    $upd[] = "        top.TRY_{$var_full_name}++;\n";
                                    $upd[] = "        top.VAL_{$var_full_name} = top.LSV_{$var_full_name};\n";
                                    $upd[] = "    } else {\n";
                                    $upd[] = "        top.TRY_{$var_full_name} = 0;\n";
                                    $upd[] = "        top.LSV_{$var_full_name} = top.VAL_{$var_full_name};\n";
                                    $upd[] = "    }\n";

                                    $upd[] = "    top.CNT_{$var_full_name}++;\n";
                                    $upd[] = "    if (top.CNT_{$var_full_name} > 8192) top.CNT_{$var_full_name} = 1;\n";
                                    $upd[] = "    top.AVG_{$var_full_name} = Math.round((top.AVG_{$var_full_name} * (top.CNT_{$var_full_name} - 1) + top.VAL_{$var_full_name}) / top.CNT_{$var_full_name});\n";
                                    $upd[] = "    if (top.VAL_{$var_full_name} > top.MAX_{$var_full_name})\n";
                                    $upd[] = "        top.MAX_{$var_full_name} = top.VAL_{$var_full_name};\n";
                                    $upd[] = "    if (top.VAL_{$var_full_name} < top.MIN_{$var_full_name})\n";
                                    $upd[] = "        top.MIN_{$var_full_name} = top.VAL_{$var_full_name};\n";
                                }
                            }
                        }
                }
            }
        }

        $need_to_set_platform_in_form_submit = false;

        if ($has_set_threshold_id1) {
            $entry_name = $HTTP_POST_VARS["_SET_THRESHOLD_ID1_"];
            $entry_oid = $snmp_entry_oid[$entry_name];
            if (!empty($entry_oid)) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_value = $HTTP_POST_VARS["_THRESHOLD_VALUE1_"];
                $secure_source_community = $secured_community[$entry_oid];
                if (empty($secure_source_community))
                    $secure_source_community = $snmp_source_community;
                else
                    $secure_source_community = str_replace("%c", $snmp_source_community, $secure_source_community);
                apply_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $acq = acquire_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $upd2[] = "    top.VAL_{$entry_name} = $acq;\n";
                if (!strcmp($value_type, OID_VALUE_STRING))
                    $upd2[] = "    top.VAL_{$entry_name} = top.VAL_{$entry_name}.replace(/^\\\"/gi, '').replace(/\\\"$/gi, '');\n";
                $alert = jscript_config_action($entry_oid, $config_actions, $entry_value);
            }

            $has_set_threshold_id1 = !empty($HTTP_POST_VARS["_UPDATE_APPLET1_"]);
            $has_set_threshold_id1 = ($has_set_threshold_id1 ? (strlen(chop($HTTP_POST_VARS["_UPDATE_APPLET1_"])) > 0) : false);

            if ($has_set_threshold_id1) {
                $event_oid = $HTTP_POST_VARS["_UPDATE_APPLET1_"];
                $span_name = str_replace('_', '', $event_oid);
                if (empty($snmp_entry_value_translation[$entry_oid])) {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.VAL_{$entry_name}.toString(), 'red');\n";
                } else {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.TRANS_{$entry_name}[top.VAL_{$entry_name}].toString(), 'red');\n";
                }
                $upd2[] = "    top.frames[4].rewriteLayer(\"ST{$span_name}\", \"". $HTTP_SESSION_VARS['msg_done']. "\", \"green\");\n";
            } else {
                $upd2[] = "    top.frames[4].rewriteLayer(\"ST{$entry_name}\", \"". $HTTP_SESSION_VARS['msg_done']. "\", \"green\");\n";
            }
            if (!empty($snmp_entry_rescan_map[$entry_oid])) {
                $remap = $snmp_entry_rescan_map[$entry_oid];
            }
            $need_to_set_platform_in_form_submit = true;
            $submitOk = "if (top.frames[4].set_id_ok) top.frames[4].set_id_ok = \"OK\";";
            $clearCurrFid = "top.frames[4].__busyForSet__ = -1;";
        }

        if ($has_set_threshold_id2) {
            $entry_name = $HTTP_POST_VARS["_SET_THRESHOLD_ID2_"];
            $entry_oid = $snmp_entry_oid[$entry_name];

            if (!empty($entry_oid)) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_value = $HTTP_POST_VARS["_THRESHOLD_VALUE2_"];
                $secure_source_community = $secured_community[$entry_oid];
                if (empty($secure_source_community))
                    $secure_source_community = $snmp_source_community;
                else
                    $secure_source_community = str_replace("%c", $snmp_source_community, $secure_source_community);
                apply_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $acq = acquire_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $upd2[] = "    top.VAL_{$entry_name} = $acq;\n";
                if (!strcmp($value_type, OID_VALUE_STRING))
                    $upd2[] = "    top.VAL_{$entry_name} = top.VAL_{$entry_name}.replace(/^\\\"/gi, '').replace(/\\\"$/gi, '');\n";
                $alert = "    ". jscript_config_action($entry_oid, $config_actions, $entry_value);
            }

            $has_set_threshold_id2 = !empty($HTTP_POST_VARS["_UPDATE_APPLET2_"]);
            $has_set_threshold_id2 = ($has_set_threshold_id2 ? (strlen(chop($HTTP_POST_VARS["_UPDATE_APPLET2_"])) > 0) : false);

            if ($has_set_threshold_id2) {
                $event_oid = $HTTP_POST_VARS["_UPDATE_APPLET2_"];
                $span_name = str_replace('_', '', $event_oid);
                if (empty($snmp_entry_value_translation[$entry_oid])) {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.VAL_{$entry_name}.toString(), 'red');\n";
                } else {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.TRANS_{$entry_name}[top.VAL_{$entry_name}].toString(), 'red');\n";
                }
            } else {
                $upd2[] = "    top.frames[4].rewriteLayer(\"ST{$entry_name}\", \"". $HTTP_SESSION_VARS['msg_done']. "\", \"green\");\n";
            }
            $need_to_set_platform_in_form_submit = true;
            $submitOk = "if (top.frames[4].set_id_ok) top.frames[4].set_id_ok = \"OK\";";
            $clearCurrFid = "top.frames[4].__busyForSet__ = -1;";
        }

        if ($has_set_threshold_id3) {
            $entry_name = $HTTP_POST_VARS["_SET_THRESHOLD_ID3_"];
            $entry_oid = $snmp_entry_oid[$entry_name];

            if (!empty($entry_oid)) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_value = $HTTP_POST_VARS["_THRESHOLD_VALUE3_"];
                $secure_source_community = $secured_community[$entry_oid];
                if (empty($secure_source_community))
                    $secure_source_community = $snmp_source_community;
                else
                    $secure_source_community = str_replace("%c", $snmp_source_community, $secure_source_community);
                apply_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $acq = acquire_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $upd2[] = "    top.VAL_{$entry_name} = $acq;\n";
                if (!strcmp($value_type, OID_VALUE_STRING))
                    $upd2[] = "    top.VAL_{$entry_name} = top.VAL_{$entry_name}.replace(/^\\\"/gi, '').replace(/\\\"$/gi, '');\n";
                $alert = "    ". jscript_config_action($entry_oid, $config_actions, $entry_value);
            }

            $has_set_threshold_id3 = !empty($HTTP_POST_VARS["_UPDATE_APPLET3_"]);
            $has_set_threshold_id3 = ($has_set_threshold_id3 ? (strlen(chop($HTTP_POST_VARS["_UPDATE_APPLET3_"])) > 0) : false);

            if ($has_set_threshold_id3) {
                $event_oid = $HTTP_POST_VARS["_UPDATE_APPLET3_"];
                $span_name = str_replace('_', '', $event_oid);
                if (empty($snmp_entry_value_translation[$entry_oid])) {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.VAL_{$entry_name}.toString(), 'red');\n";
                } else {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.TRANS_{$entry_name}[top.VAL_{$entry_name}].toString(), 'red');\n";
                }
            } else {
                $upd2[] = "    top.frames[4].rewriteLayer(\"ST{$entry_name}\", \"". $HTTP_SESSION_VARS['msg_done']. "\", \"green\");\n";
            }
            $need_to_set_platform_in_form_submit = true;
            $submitOk = "if (top.frames[4].set_id_ok) top.frames[4].set_id_ok = \"OK\";";
            $clearCurrFid = "top.frames[4].__busyForSet__ = -1;";
        }

        if ($has_set_threshold_id4) {
            $entry_name = $HTTP_POST_VARS["_SET_THRESHOLD_ID4_"];
            $entry_oid = $snmp_entry_oid[$entry_name];

            if (!empty($entry_oid)) {
                $value_type = $snmp_entry_value_type[$entry_oid];
                $entry_value = $HTTP_POST_VARS["_THRESHOLD_VALUE4_"];
                $secure_source_community = $secured_community[$entry_oid];
                if (empty($secure_source_community))
                    $secure_source_community = $snmp_source_community;
                else
                    $secure_source_community = str_replace("%c", $snmp_source_community, $secure_source_community);
                apply_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $acq = acquire_single_value($snmp_source_ip_address, $secure_source_community, $entry_oid, $value_type, $entry_value);
                $upd2[] = "    top.VAL_{$entry_name} = $acq;\n";
                if (!strcmp($value_type, OID_VALUE_STRING))
                    $upd2[] = "    top.VAL_{$entry_name} = top.VAL_{$entry_name}.replace(/^\\\"/gi, '').replace(/\\\"$/gi, '');\n";
                $alert = "    ". jscript_config_action($entry_oid, $config_actions, $entry_value);
            }

            $has_set_threshold_id4 = !empty($HTTP_POST_VARS["_UPDATE_APPLET4_"]);
            $has_set_threshold_id4 = ($has_set_threshold_id4 ? (strlen(chop($HTTP_POST_VARS["_UPDATE_APPLET4_"])) > 0) : false);

            if ($has_set_threshold_id4) {
                $event_oid = $HTTP_POST_VARS["_UPDATE_APPLET4_"];
                $span_name = str_replace('_', '', $event_oid);
                if (empty($snmp_entry_value_translation[$entry_oid])) {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\", top.VAL_{$entry_name}.toString(), 'red');\n";
                } else {
                    $upd2[] = "    top.frames[4].rewriteLayer(\"V{$span_name}\', top.TRANS_{$entry_name}[top.VAL_{$entry_name}].toString(), 'red');\n";
                }
            } else {
                $upd2[] = "    top.frames[4].rewriteLayer(\"ST{$entry_name}\", \"". $HTTP_SESSION_VARS['msg_done']. "\", \"green\");\n";
            }
            $need_to_set_platform_in_form_submit = true;
            $submitOk = "if (top.frames[4].set_id_ok) top.frames[4].set_id_ok = \"OK\";";
            $clearCurrFid = "top.frames[4].__busyForSet__ = -1;";
        }

        if ($need_to_set_platform_in_form_submit) {
            $upd3 = "top.__platform_in_form_submit__ = false;\n";
        }
    }
?>
<HTML>
<HEAD>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</HEAD>
<script language="javascript">
<!--
<?php echo $submitOk;?>

<?php echo $clearCurrFid;?>


function periodical ()
{
<?php
                    if (!empty($alert))
                        echo $alert;

                    if (count($upd2) > 0)
                        $always_rewriteDynaContent = false;

                    if ($always_rewriteDynaContent) {?>

    if (top.frames[4].rewriteDynaContent)
        top.frames[4].rewriteDynaContent();

<?php

                        for ($i = 0; $i < count($upd); $i++) {
                            echo $upd[$i];
                        }

                    } else {?>

    if (top.frames[4].rewriteLayer) {

<?php
                        for ($i = 0; $i < count($upd2); $i++) {
                            echo "    ", $upd2[$i];
                        }?>

        top.frames[4].renewLimits();
    }
<?php
                    }

                    if (strlen($remap) > 0) {
                        echo "    top.window.location.replace(\"remap.php?s=\" + escape(top.__platform_in_view__)  + \"&p=\" + escape(top.__panel_in_view__) + \"&map=$remap\");\n";
                    }
?>
}
//-->
</script>
<BODY BGCOLOR="#CEE7FF" background="/images/bg.gif" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
</BODY>
<script language="javascript">
<!--
periodical();
<?php
    if (!empty($upd3))
        echo $upd3;
?>
//-->
</script>
</HTML>
