<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    include("___defines___.php");
    include("___defines2___.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</HEAD>
<?php
    $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
    $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];

    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $summary_category = $HTTP_SESSION_VARS["summary_category"];
    $summary_category_value_type = $HTTP_SESSION_VARS["summary_category_value_type"];
    $summary_category_attribute = $HTTP_SESSION_VARS["summary_category_attribute"];

    $static_values = $HTTP_SESSION_VARS["static_values"];

    $summary_info_load = $HTTP_SESSION_VARS["summary_info_load"];
    $summary_info_load = '1';
    $initview = $HTTP_SESSION_VARS['initview'];
    if (empty($initview))
        $initview = "front";

    if (!empty($summary_category_value_type))
        foreach ($summary_category_value_type as $entry_oid => $value_type) {
            $attribute = $summary_category_attribute[$entry_oid];
            $entry_name = $summary_category[$entry_oid];
            if (!empty($snmp_entry_name[$entry_oid])) {
                if (!strcmp($attribute, OID_ATTR_INFO) ||
                    !strcmp($attribute, OID_ATTR_WATCH) || !strcmp($attribute, OID_ATTR_WATCHRAID)) {
                    $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                    if (!strcmp($attribute, OID_ATTR_WATCHRAID)) {
                        list($nrdisk, $actdisk, $workdisk, $faildisk, $sparedisk, $resync, $recovery) = explode(':', ereg_replace('^\"(.*)\"$', '\\1', $acq));
                        $vvars[] = "var VAL_{$entry_name}_nrdisk = $nrdisk, VAL_{$entry_name}_actdisk = $actdisk, VAL_{$entry_name}_workdisk = $workdisk;\n";
                        $vvars[] = "var VAL_{$entry_name}_faildisk = $faildisk, VAL_{$entry_name}_sparedisk = $sparedisk, VAL_{$entry_name}_resync = $resync, VAL_{$entry_name}_recovery = $recovery;\n";
                    } else {
                        $vvars[] = "var VAL_{$entry_name} = $acq;\n";
                    }
                }
            } else {
                $static = $static_values[$entry_oid];
                if (!empty($static)) {
                    $vvars[] = "var VAL_{$entry_name} = \"{$static}\";\n";
                }
            }
        }

    $vars[] = "";
    $view_settings = $HTTP_SESSION_VARS["summary_". $initview. "_view"];
    if (!empty($view_settings)) {
        $view_alarm = $HTTP_SESSION_VARS["view_alarm_". $initview];
        _gen_alarm_vars_($HTTP_SESSION_VARS["view_alarm_front"], &$vars);
        _gen_alarm_vars_($HTTP_SESSION_VARS["view_alarm_rear"], &$vars);
        _gen_alarm_vars_($HTTP_SESSION_VARS["view_alarm_top"], &$vars);
    }
?>

<script language=javascript>
<!--
var __current_infoShow__ = '';
<?php
    for ($i = 0; $i < count($vvars); $i++) {
        echo $vvars[$i];
    }
?>


<?php
    for ($i = 0; $i < count($vars); $i++) {
        if (strlen($vars[$i]) > 0)
            echo "var A{$vars[$i]} = '", ALARM_NORMAL, "';\n";
    }
?>

var __begin_to_showHide__ = false;

function toggleInfoLight2 ()
{
    if (!__begin_to_showHide__)
        return;

    if (self.frames[1].toggleInfoLight2)
        self.frames[1].toggleInfoLight2();

    if (self.frames[2].toggleInfoLight2)
        self.frames[2].toggleInfoLight2();
}

function toggleInfoLight ()
{
    if (!__begin_to_showHide__)
        return;

    if (self.frames[1].toggleInfoLight)
        self.frames[1].toggleInfoLight();

    if (self.frames[2].toggleInfoLight)
        self.frames[2].toggleInfoLight();
}

function rewriteDynaContent ()
{
    if (!__begin_to_showHide__)
        return;

    if (self.frames[2].rewriteDynaContent)
        self.frames[2].rewriteDynaContent();

    if (self.frames[3].rewriteDynaContent)
        self.frames[3].rewriteDynaContent();
}
//-->
</script>

<frameset rows="40,318,*" frameborder="0" border="0" framespacing="0">
    <frame scrolling="no" noresize src="summtitle.php" marginwidth="0" marginheight="0">
<?php
    if (!empty($view_settings)) {?>
    <frameset cols="250,*" frameborder="0" border="0" framespacing="0">
<?php
    } else {?>
    <frameset cols="400,*" frameborder="0" border="0" framespacing="0">
<?php
    }?>
        <frame name="left" src="summleft.php?v=<?php echo $initview;?>&n=1" marginwidth="0" marginheight="0" scrolling="no">
        <frame name="rite" src="_blank3_.html" marginwidth="0" marginheight="0" scrolling="no">
    </frameset>
    <frame scrolling="yes" src="summoid.php" marginwidth="0" marginheight="0">
</frameset>

</HTML>
